#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int
secwrite (char *file, char *string)
{

  FILE *f;
  int fd;
  struct stat first, after;


  if (lstat (file, &first) == -1)
    {
      perror ("lstat");
      exit (-1);
    }

  if ((fd = open (file, O_RDWR)) == -1)
    {
      perror ("open");
      exit (-1);
    };


  if (fstat (fd, &after) == -1)
    {
      perror ("fstat");
      exit (-1);
    }
  if (first.st_mode == after.st_mode && first.st_dev == after.st_dev)
    {


      if ((f = fdopen (fd, "wb+")) != NULL)
	{

	  fprintf (f, string);
	  fflush (f);

	  fclose (f);
	}

    }
  else
    close (fd);


  return 2;
}

int
main (int argc, char **argv)
{

  if (argc != 3)
    {
      fprintf (stderr, "USAGE %s : file string\n", argv[0]);
      exit (-1);
    }


  if (secwrite (argv[1], argv[2]) == 2)
    printf ("Done\n");


  return 0;
}
