/*
    UniSFED Copyright (C) 2003 Paolo Ardoino <ardoino.gnu@disi.unige.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


void help(char *name)
{
	printf("UniSFED [Simple File Encrypter/Decrypter] v%s\n",VERSION);
	printf("Coded by Paolo Ardoino <ardoino.gnu@disi.unige.it>\n");
	printf("Usage:\n");
	printf("%s -h\t:displays this help\n",name);
	printf("%s -fh <file_to_hash>\t:performs the MD5 hash of file_to_hash.\n",name);
	printf("%s -fc <file1_to_cmp> <file2_to_cmp>\t:compares the MD5 hash of the two files.\n",name);
	printf("%s -e <-idea|-des|-bf|-rsa> <file_to_crypt> <file_output> [rsa_pub.pem]]\t:encrypts file_to_crypt with choosen cipher.\n",name);
	printf("%s -d <-idea|-des|-bf|-rsa> <file_to_decrypt> <file_output> [rsa_sec.pem]\t:decrypts file_to_decrypt with choosen cipher.\n",name);
	printf("%s -grsa <numbits> <secfile> <pubfile>\t:generates a RSA key pair.\n", name);
	printf("-idea: idea block cipher.\n");
	printf(" -des: des block cipher.\n");
	printf("  -bf: blowfish block cipher.\n");
	printf("Ex: %s -e -bf passwords.txt crypto_pass.txt\n",name);
	printf("Ex: %s -d -bf crypto_pass.txt pass_file.txt\n",name);
	printf("Ex: %s -fc file1 file2\n",name);
	printf("\nPlease report bugs to <ardoino.gnu@disi.unige.it>\n");
	return;
}

/*
 * fexists() checks for the existence of a given file.
 * return 0 if the file doesn't exist and 1 if it exists.
 */
int fexists(char *file)
{	
	FILE *fp;
	if ((fp = fopen(file,"r")) == NULL) {
		return 0;
	} else {
		fclose(fp);
		return 1;
	}
}
